create or replace function fr_irb_clnpspfm_get_workdays(nrn_     in number,
                                                        ddateb   in date,
                                                        ddateend in date)
  return number as
  nresult pkg_std.tnumber;
  nresult2 pkg_std.tnumber;
  nmonthb number(2);
  nmonthe number(2);
  nyearb  number(4);
  ddatef  date;
  ddatee  date;
  ddateb2 date;
  ddateend2 date;
begin
 nresult:=0;
  --   
  nmonthb := to_number(to_char(ddateb, 'mm'));
  nyearb  := to_number(to_char(ddateb, 'yyyy'));
  nmonthe := to_number(to_char(ddateend, 'mm'));
  --   
  for c in nmonthb .. nmonthe loop
    --   
    ddatef := to_date('01.' || to_char(c) ||'.' ||to_char(nyearb), 'dd.mm.yyyy');
    ddatee := last_day(ddatef);
    --     
    if to_number(to_char(ddateb, 'mm'))=c then ddateb2:=ddateb; 
    else ddateb2:=ddatef;
    end if;
    if to_number(to_char(ddateend, 'mm'))=c then ddateend2:=ddateend; 
    else
    ddateend2:=ddatee;
    end if;
    select count(wd.nrn)
      into nresult2
      from clnpspfm   clfm,
           clnpspfmhs h,
           slschedule s,
           enperiod   endp,
           v_workdays wd
     where clfm.rn = nrn_
       and clfm.rn = h.prn
       and h.schedule = s.rn
       and s.rn = endp.schedule
       and endp.enddate between ddatef and ddatee
       and endp.rn = wd.nprn
       and wd.nworkdaynorm != 0
       and ndays between to_number(to_char(ddateb2, 'dd')) and
           to_number(to_char(ddateend2, 'dd'));
  nresult:=nresult+nresult2;         
  end loop;
  return nresult;
end;
/
